package com.hai.service;



import com.hai.entity.CmsCategoryModule;
import com.hai.model.CmsCategoryModuleModel;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: CmsCategoryModuleService
 * @Description: 内容管理 模板
 * @author: gongjia
 * @date: 2019/10/30 9:09
 * @Copyright: 2019 www.shinwoten.com Inc. All rights reserved.
 */
public interface CmsCategoryModuleService {

    /**
     *
     * @Title: addCategoryModule
     * @Description: 添加模板
     * @author: gongjia
     * @param: [cmsCategoryModule, files]
     * @return: int
     * @throws
     */
    int addCategoryModule(CmsCategoryModule cmsCategoryModule) throws Exception;

    /**
     *
     * @Title: updateCategoryModule
     * @Description: 修改模板
     * @author: gongjia
     * @param: [cmsCategoryModule, files]
     * @return: int
     * @throws
     */
    int updateCategoryModule(CmsCategoryModule cmsCategoryModule) throws Exception;

    /**
     *
     * @Title: delCategoryModule
     * @Description: 删除模板
     * @author: gongjia
     * @param: [id]
     * @return: int
     * @throws
     */
    int delCategoryModule(Long id) throws Exception;

    /**
     *
     * @Title: getCategoryModuleById
     * @Description: 根据id 查询模板
     * @author: gongjia
     * @param: [id]
     * @return: com.ncsmesc.entity.CmsCategoryModule
     * @throws
     */
    CmsCategoryModule getCategoryModuleById(Long id) throws Exception;

    /**
     *
     * @Title: getListCategoryModule
     * @Description: 查询列表 模板
     * @author: gongjia
     * @param: [paramsMap]
     * @return: java.util.List<com.ncsmesc.entity.CmsCategoryModule>
     * @throws
     */
    List<CmsCategoryModuleModel> getListCategoryModule(Map<String, Object> paramsMap) throws Exception;

}
